import ChromeFirefoxPushController from './controllers/ChromeFirefoxPushController';
import SafariPushController from './controllers/SafariPushController';

const WEB_CHROME = "WEB_CHROME";
const WEB_SAFARI = "WEB_SAFARI";
const WEB_FIREFOX = "WEB_FIREFOX";
let platform;

const getPlatformController = function() {
    var objAgent = window.navigator.userAgent; 
    // In Chrome 
    if (objAgent.indexOf("Chrome") !== -1) { 
      platform = WEB_CHROME;
      return new ChromeFirefoxPushController();
    }
    // In Firefox 
    else if (objAgent.indexOf("Firefox") !== -1) {
      platform = WEB_FIREFOX;
      return new ChromeFirefoxPushController();
    } 
    // In Safari 
    else if (objAgent.indexOf("Safari") !== -1) {
      platform = WEB_SAFARI;
      return new SafariPushController();
    }
};

export {platform, getPlatformController};